package org.example;

import java.lang.reflect.Array;
import java.lang.reflect.Method;
import java.util.Arrays;

// Press Shift twice to open the Search Everywhere dialog and type `show whitespaces`,
// then press Enter. You can now see whitespace characters in your code.
public class Main {
    public static void main(String[] args) {
        Class<?> integerClass = Integer.class;
        System.out.println(integerClass.getName());  // Output: java.lang.Integer

        try {
            Object integerObject = integerClass.getDeclaredConstructor(int.class).newInstance(42);
            Method toStringMethod = integerClass.getMethod("toString");
            String result = (String) toStringMethod.invoke(integerObject);
            System.out.println(result);  // Output: 42
        } catch (Exception e) {
            e.printStackTrace();
        }

        Integer someVariable = 3;
        if (someVariable.getClass() == Integer.TYPE) {
            System.out.println("The variable is of type int.");
        } else {
            System.out.println("The variable is not of type int.");
        }

        if (someVariable.getClass() == Integer.TYPE) {
            int value = (int) someVariable;
            // Process int value
        } else if (someVariable instanceof Integer) {
            Integer value = (Integer) someVariable;
            // Process Integer object
        } else {
            throw new IllegalArgumentException("Unsupported number type.");
        }

        Class<?> intClass = int.class;
        System.out.println(intClass.getName());  // Output: int

        int[] numbers = (int[]) Array.newInstance(int.class, 5);
        for (int i = 0; i < numbers.length; i++) {
            numbers[i] = i + 1;
        }
        System.out.println(Arrays.toString(numbers));  // Output: [1, 2, 3, 4, 5]
    }
}